/**
 * donutty // Create SVG donut charts with Javascript
 * @author simeydotme <simey.me@gmail.com>
 * @version 1.1.3
 * @license ISC
 * @link http://simey.me
 * @preserve
 */
!function(n,t){function o(t){return void 0!==t}function e(t){return parseFloat(t,10)}function r(t){return o(t)&&(!0===t||"true"===t)}var i=window.Donutty=function(t,i){var s=this;return t&&"string"==typeof t?s.$wrapper=n.querySelectorAll(t)[0]:t instanceof window.HTMLElement?s.$wrapper=t:(s.$wrapper=n.body,i=t),s.state={},s.options=i||{},s.options.min=o(s.options.min)?e(s.options.min):0,s.options.max=o(s.options.max)?e(s.options.max):100,s.options.value=o(s.options.value)?e(s.options.value):50,s.options.round=!o(s.options.round)||r(s.options.round),s.options.circle=!o(s.options.circle)||r(s.options.circle),s.options.padding=o(s.options.padding)?e(s.options.padding):4,s.options.radius=e(s.options.radius)||50,s.options.thickness=e(s.options.thickness)||10,s.options.bg=s.options.bg||"rgba(70, 130, 180, 0.15)",s.options.color=s.options.color||"mediumslateblue",s.options.transition=s.options.transition||"all 1.2s cubic-bezier(0.57, 0.13, 0.18, 0.98)",s.init(),s};i.prototype.init=function(){return this.state.min=this.options.min,this.state.max=this.options.max,this.state.value=this.options.value,this.state.bg=this.options.bg,this.state.color=this.options.color,this.createFragments(),this},i.prototype.createFragments=function(){var t="http://www.w3.org/2000/svg",i=2*this.options.radius+this.options.thickness+2*this.options.padding,s=this.getDashValues(),o=this.options.round?this.options.thickness/3:0,e=this.options.circle?90+o:-225;return this.$html=n.createDocumentFragment(),this.$svg=n.createElementNS(t,"svg"),this.$bg=n.createElementNS(t,"circle"),this.$donut=n.createElementNS(t,"circle"),this.$svg.setAttribute("xmlns",t),this.$svg.setAttribute("viewbox","0 0 "+i+" "+i),this.$svg.setAttribute("transform","rotate( "+e+" )"),this.$svg.style.width=i,this.$svg.style.height=i,this.$bg.setAttribute("cx","50%"),this.$bg.setAttribute("cy","50%"),this.$bg.setAttribute("r",this.options.radius),this.$bg.setAttribute("fill","transparent"),this.$bg.setAttribute("stroke",this.state.bg),this.$bg.setAttribute("stroke-width",this.options.thickness+this.options.padding),this.$bg.setAttribute("stroke-dasharray",s.full*s.multiplier),this.$donut.setAttribute("fill","transparent"),this.$donut.setAttribute("cx","50%"),this.$donut.setAttribute("cy","50%"),this.$donut.setAttribute("r",this.options.radius),this.$donut.setAttribute("stroke",this.state.color),this.$donut.setAttribute("stroke-width",this.options.thickness),this.$donut.setAttribute("stroke-dashoffset",s.full),this.$donut.setAttribute("stroke-dasharray",s.full),this.$donut.style.opacity=0,this.options.round&&(this.$bg.setAttribute("stroke-linecap","round"),this.$donut.setAttribute("stroke-linecap","round")),this.$svg.appendChild(this.$bg),this.$svg.appendChild(this.$donut),this.$html.appendChild(this.$svg),this.$wrapper.appendChild(this.$html),this.animate(s.fill,s.full),this},i.prototype.getDashValues=function(){var t,i,s,o;return o=this.options.circle?1:.75,s=(t=2*Math.PI*this.options.radius)-t*o/100*(i=(this.state.value-this.state.min)/(this.state.max-this.state.min)*100),this.options.round&&this.options.circle&&i<100&&s<this.options.thickness&&(s=this.options.thickness),{fill:s,full:t,multiplier:o}},i.prototype.animate=function(t,i){var s=this;s.$bg.style.transition=this.options.transition,s.$donut.style.transition=this.options.transition,window.setTimeout(function(){s.$donut.setAttribute("stroke-dashoffset",t),s.$donut.setAttribute("stroke-dasharray",i),s.$bg.setAttribute("stroke",s.state.bg),s.$donut.setAttribute("stroke",s.state.color),s.$donut.style.opacity=1},16)},i.prototype.set=function(t,i){var s;return o(t)&&o(i)&&(this.state[t]=i,s=this.getDashValues(),this.animate(s.fill,s.full)),this},i.prototype.setState=function(t){var i;return o(t.value)&&(this.state.value=t.value),o(t.min)&&(this.state.min=t.min),o(t.max)&&(this.state.max=t.max),o(t.bg)&&(this.state.bg=t.bg),o(t.color)&&(this.state.color=t.color),i=this.getDashValues(),this.animate(i.fill,i.full),this}}(document),function(n,r){void 0!==window.$?r(function(){r.fn.donutty=function(e){return r(this).each(function(t,i){var s=r(i),o=new n(i,r.extend({},s.data(),e));s.data("donutty",o)})},r("[data-donutty]").donutty()}):console.warn("Can't find jQuery to attach Donutty")}(Donutty,jQuery);