/**
 * donutty // Create SVG donut charts with Javascript
 * @author simeydotme <simey.me@gmail.com>
 * @version 1.1.3
 * @license ISC
 * @link http://simey.me
 * @preserve
 */
!function(n,t){function o(t){return void 0!==t}function e(t){return parseFloat(t,10)}function r(t){return o(t)&&(!0===t||"true"===t)}var s=window.Donutty=function(t,s){var i=this;return t&&"string"==typeof t?i.$wrapper=n.querySelectorAll(t)[0]:t instanceof window.HTMLElement?i.$wrapper=t:(i.$wrapper=n.body,s=t),i.state={},i.options=s||{},i.options.min=o(i.options.min)?e(i.options.min):0,i.options.max=o(i.options.max)?e(i.options.max):100,i.options.value=o(i.options.value)?e(i.options.value):50,i.options.round=!o(i.options.round)||r(i.options.round),i.options.circle=!o(i.options.circle)||r(i.options.circle),i.options.padding=o(i.options.padding)?e(i.options.padding):4,i.options.radius=e(i.options.radius)||50,i.options.thickness=e(i.options.thickness)||10,i.options.bg=i.options.bg||"rgba(70, 130, 180, 0.15)",i.options.color=i.options.color||"mediumslateblue",i.options.transition=i.options.transition||"all 1.2s cubic-bezier(0.57, 0.13, 0.18, 0.98)",i.init(),i};s.prototype.init=function(){return this.state.min=this.options.min,this.state.max=this.options.max,this.state.value=this.options.value,this.state.bg=this.options.bg,this.state.color=this.options.color,this.createFragments(),this},s.prototype.createFragments=function(){var t="http://www.w3.org/2000/svg",s=2*this.options.radius+this.options.thickness+2*this.options.padding,i=this.getDashValues(),o=this.options.round?this.options.thickness/3:0,e=this.options.circle?90+o:-225;return this.$html=n.createDocumentFragment(),this.$svg=n.createElementNS(t,"svg"),this.$bg=n.createElementNS(t,"circle"),this.$donut=n.createElementNS(t,"circle"),this.$svg.setAttribute("xmlns",t),this.$svg.setAttribute("viewbox","0 0 "+s+" "+s),this.$svg.setAttribute("transform","rotate( "+e+" )"),this.$svg.style.width=s,this.$svg.style.height=s,this.$bg.setAttribute("cx","50%"),this.$bg.setAttribute("cy","50%"),this.$bg.setAttribute("r",this.options.radius),this.$bg.setAttribute("fill","transparent"),this.$bg.setAttribute("stroke",this.state.bg),this.$bg.setAttribute("stroke-width",this.options.thickness+this.options.padding),this.$bg.setAttribute("stroke-dasharray",i.full*i.multiplier),this.$donut.setAttribute("fill","transparent"),this.$donut.setAttribute("cx","50%"),this.$donut.setAttribute("cy","50%"),this.$donut.setAttribute("r",this.options.radius),this.$donut.setAttribute("stroke",this.state.color),this.$donut.setAttribute("stroke-width",this.options.thickness),this.$donut.setAttribute("stroke-dashoffset",i.full),this.$donut.setAttribute("stroke-dasharray",i.full),this.$donut.style.opacity=0,this.options.round&&(this.$bg.setAttribute("stroke-linecap","round"),this.$donut.setAttribute("stroke-linecap","round")),this.$svg.appendChild(this.$bg),this.$svg.appendChild(this.$donut),this.$html.appendChild(this.$svg),this.$wrapper.appendChild(this.$html),this.animate(i.fill,i.full),this},s.prototype.getDashValues=function(){var t,s,i,o;return o=this.options.circle?1:.75,i=(t=2*Math.PI*this.options.radius)-t*o/100*(s=(this.state.value-this.state.min)/(this.state.max-this.state.min)*100),this.options.round&&this.options.circle&&s<100&&i<this.options.thickness&&(i=this.options.thickness),{fill:i,full:t,multiplier:o}},s.prototype.animate=function(t,s){var i=this;i.$bg.style.transition=this.options.transition,i.$donut.style.transition=this.options.transition,window.setTimeout(function(){i.$donut.setAttribute("stroke-dashoffset",t),i.$donut.setAttribute("stroke-dasharray",s),i.$bg.setAttribute("stroke",i.state.bg),i.$donut.setAttribute("stroke",i.state.color),i.$donut.style.opacity=1},16)},s.prototype.set=function(t,s){var i;return o(t)&&o(s)&&(this.state[t]=s,i=this.getDashValues(),this.animate(i.fill,i.full)),this},s.prototype.setState=function(t){var s;return o(t.value)&&(this.state.value=t.value),o(t.min)&&(this.state.min=t.min),o(t.max)&&(this.state.max=t.max),o(t.bg)&&(this.state.bg=t.bg),o(t.color)&&(this.state.color=t.color),s=this.getDashValues(),this.animate(s.fill,s.full),this}}(document),function(o){var t=document,s=function(){var t=document.querySelectorAll("[data-donutty]");Array.prototype.forEach.call(t,function(t){var s=JSON.parse(JSON.stringify(t.dataset)),i=new o(t,s);t.dataset.donutty=i})};"complete"===t.readyState||"loading"!==t.readyState&&!t.documentElement.doScroll?s():t.addEventListener("DOMContentLoaded",s)}(Donutty);